import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import static jdk.nashorn.internal.objects.NativeArray.lastIndexOf;

public class ArrayListTest {



    @Before
    public void setup(){


    }

    @Test
    public void AddTest(){

        //Given
        ArrayList arrayList = new ArrayList();

     //When

        for (int i = 0; i < 19; i++) {
            arrayList.add(i);
        }

        int actual = arrayList.size();
        int expecting = 19;


        //Then

        Assert.assertEquals(actual,expecting);


    }

    @Test
    public void addBoolean(){

        //Given
        ArrayList arrayList = new ArrayList();

        //When
        int r = 2;

         Boolean actual= arrayList.adding(r);

        //Then
        Assert.assertTrue(actual);

    }
    @Test
    public void addBooleanIndex(){

        //Given
        ArrayList arrayList = new ArrayList();

        //When
        int r = 2;



        for (int i = 0; i < 4; i++) {
            arrayList.add(i);
        }
        Boolean actual= arrayList.addingIndex(9,r);
        //Then
        Assert.assertTrue(actual);

    }

    @Test
    public void removeTest(){
        //Given
        ArrayList arrayList = new ArrayList();

        //When

        for (int i = 0; i < 19; i++) {
            arrayList.add(i);
        }
        arrayList.remove(10);
        int actual = arrayList.size();
        int expecting = 18;


        //Then

        Assert.assertEquals(expecting,actual);
    }

    @Test
    public  void containsTest(){

        //Given

        ArrayList arrayList = new ArrayList();

        //When
        for (int i = 0; i < 4; i++) {
            arrayList.add(i);
        }
       Boolean actual = arrayList.contains(2);

        //Then

        Assert.assertTrue(actual);

    }

    @Test
    public void getTest(){

        //Given

        ArrayList arrayList = new ArrayList();

        //When
        for (int i = 0; i < 4; i++) {
            arrayList.add(i);
        }
        //Then

        int expect = 2;
        Object actual = arrayList.get(2);
        Assert.assertEquals(expect,actual);

    }

    @Test
    public void setTest(){

        //Given
        ArrayList arrayList = new ArrayList();
        //When
        for (int i = 0; i < 4; i++) {
            arrayList.add(i);
        }
        //Then
        int expect = 7;
         arrayList.set(3,6);
        arrayList.set(3,7);
        Object actual = arrayList.get(3);
        Assert.assertEquals(expect,actual);


    }
    @Test
    public void clearTest(){

        //Given
        ArrayList arrayList = new ArrayList();

        //When
        for (int i = 0; i < 19; i++) {
            arrayList.add(i);
        }
        arrayList.clear();
        //Then
        int actual = arrayList.size();
        int expecting = 0;

        Assert.assertEquals(expecting,actual);


    }

    @Test
    public void itsEmptyTest(){

        //Given
        ArrayList arrayList = new ArrayList();
       // arrayList.add(4);
        //When
        Boolean actual = arrayList.isEmpty();
        //Then
        Assert.assertTrue(actual);


    }





    @Test
    public void indexOfTest(){

        //Given

        ArrayList arrayList = new ArrayList();

        //When
        for (int i = 0; i < 5; i++) {
            arrayList.add(i);
        }
        int expecting  = 3;
        int actual = arrayList.getIndexOf(3);

        //Then

        Assert.assertEquals(expecting,actual);
    }

}
